---
schema_version: "1"
id: e44299346825dd64dde13758349ea23090628337f081b00d775c8e7e5dd92fd1
title: Configure, Price, Quote (CPQ) REST APIs
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries/cme/references/generated-api-specs/cpq.md
canonical_url: https://developer.salesforce.com/docs/industries/cme/references/cpq
source_site: developer.salesforce.com
content_type: documentation
content_hash: e48ec59fceace66c7289052ce5d3a06b2464169fc274e9a92e1dff8921fd1a34
products:
  - Communications, Media, Energy and Utilities APIs (Managed Package)
  - Industries Developer Documentation
---
Configure, Price, Quote (CPQ) REST APIs

# Configure, Price, Quote (CPQ) REST APIs

**Partial reference:** 1 operation(s) were omitted because their source references could not be resolved.

Industries Configure, Price, Quote Web APIs (CPQ APIs) enable client application users to shop for and order products and services. The CPQ APIs provide a layer of abstraction between the client app developers and the CPQ developers who are configuring and customizing the underlying CPQ logic.

*   V2 of the CPQ APIs simplifies the APIs for mobile and external app development. The v2 APIs are the default APIs used by Industries applications. Base URL for the apis described is 'xx##.salesforce.com/services/apexrest/vlocity\_cmt/v2'.
*   To refer and access CPQ APIs swagger file (DEPRECATED), click [here](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/cpqapi.yaml.zip) to download. You can use an editor like editor.swagger.io to view the swagger based API doc.

**Version:** Summer 2024

## Servers

*   `https://{MyDomainLoginUrl}.salesforce.com/services/apexrest/vlocity_cmt/v2`

Protocols: https.

## Operations

### POST Create Cart

`POST /carts`

Operation ID: `CreateCart`. Tags: Cart.

Creates an opportunity, order, or quote based on the subaction specified in the request body. Subaction also defines method of creation. NOTE: The inputFields is not supported for AssetToOrder (subaction as assetToOrder). Subactions supported include.

**createOrder** - Create an empty order from the specified inputs.

**createQuote** - Create an empty quote from the specified inputs.

**createOppty** - Create an empty opportunity from the specified inputs.

**assetToOrder** - Create a change order initially populated from the specified assets.

**assetToQuote** - Create a quote for changes initially populated from the specified assets.

**assetChangeSite** - Create a change order to request moving the specified assets from one service location to another.

\*\* Rest Handler - CpqCreateCartActionV2. Method Invoked - postCartItems.\*\*

#### Request body (required)

Different request bodies must be used for each of the different subactions.

#### createOrder Request Example

```json
{
    "subaction":"createOrder",
    "inputFields":[
      {  "effectivedate":"2017-12-25"  },
      {  "status":"Draft"  },
      {  "Name":"New customer order"  },
      {  "AccountId":"0016A0000053kHN"  },
      {  "Pricebook2Id":"01s6A000002Y7wz"  },
      {  "pricebookName":"GeneralPricebook"  },
      {  "pricelistName":"GeneralPricelist"  },
      {  "vlocity_cmt__OriginatingChannel__c":"Retail"  }
    ],
    "fields":"Id,Name,EffectiveDate,AccountId,Account.Name,vlocity_cmt__EffectiveRecurringTotal__c,vlocity_cmt__EffectiveOneTimeTotal__c,vlocity_cmt__EffectiveOrderTotal__c,TotalAmount,vlocity_cmt__OriginatingChannel__c,OrderNumber,OrderReferenceNumber,Pricebook2Id,pricebookName,pricelistName"
}
```

#### createQuote Request Example

```json
{
    "subaction":"createQuote",
    "inputFields":[
      {  "AccountId":"0016A0000053kHN"  },
      {  "OpportunityId":"0066A000002aVklQAE"  },
      {  "status":"Draft"  },
      {  "Name":"New customer quote"  },
      {  "Pricebook2Id":"01s6A000002Y7wz"  },
      {  "pricebookName":"GeneralPricebook"  },
      {  "pricelistName":"GeneralPricelist"  },
      {  "vlocity_cmt__OriginatingChannel__c":"Retail"  }
    ],
    "fields":"Id,QuoteNumber,Name,OpportunityId,Status,AccountId,Account.Name,vlocity_cmt__EffectiveRecurringTotal__c,vlocity_cmt__EffectiveOneTimeTotal__c,vlocity_cmt__EffectiveQuoteTotal__c,GrandTotal,vlocity_cmt__OriginatingChannel__c,pricebookName,pricelistName"
}
```

#### createOppty Request Example

```json
{
    "subaction":"createOppty",
    "inputFields":[
      {  "AccountId":"0016A0000053kHN"  },
      {  "StageName":"Prospecting"  },
      {  "Name":"New customer opportunity"  },
      {  "Type":"New Customer"  },
      {  "CloseDate":"2017-12-25"  },
      {  "vlocity_cmt__NumberOfContractedMonths__c":24  },
      {  "Pricebook2Id":"01s6A000002Y7wz"  },
      {  "pricebookName":"GeneralPricebook"  },
      {  "pricelistName":"GeneralPricelist"  },
      {  "vlocity_cmt__OriginatingChannel__c":"Dealer"  }
    ],
    "fields":"Id,Name,AccountId,Account.Name,vlocity_cmt__EffectiveRecurringTotal__c,vlocity_cmt__EffectiveOneTimeTotal__c,vlocity_cmt__EffectiveOpportunityTotal__c,Amount,vlocity_cmt__OriginatingChannel__c,pricebookName,pricelistName"
}
```

#### assetToOrder Request Example

```json
{
  "subaction":"assetToOrder",
  "id":"01t36000000pfcKAAQ,02i6A000000YEXN",
  "accountId":"0016A0000072D3y",
  "requestDate":"2017-12-01"
}
```

For assetToOrder, if future-dated order is not available, the requestDate should be greater than or equal to current date.

If a future dated order(s) is/are available for that asset, the requestDate should be greater than or equal to

current date and should be greater than or equal to the date on all the future dated orders of the asset.

For assetToOrder, the field id can be a list of all assets or just the root asset.

The child assets will be retrived from the root asset.

#### assetToQuote Request Example

```json
{
  "subaction":"assetToQuote",
  "listTypeAsset":"Service", 
  "assetIdList":[ "02i5g000000tDi8" ], 
  "accountId":"0015g000002vauG",
  "quoteId":"0065g000002fIKa",
  "opportunityId":null,
  "validate":false,
  "price":false
}
```

For assetToQuote, the parametrs "quoteId","oportunityId","validate", and "price" are optional parameters. If the user passes quoteId, then opportunityId will be ignored. If the user passes opportunityId, but not quoteId, then the API will create a new Quote for that opportunity and move assets to the created quote. If the user passes neither quoteId not opportunityId, then the API will create a new opportunity record and a new quote for that opportunity. It will then move assets to the created quote. Default values of "validate" and "price" is true. User can pass false and turn off pricing and validation.

#### assetChangeSite Request Example

````json
{
  "OrderId":"8014x000000Y8ZzAAK"
  "moveOutDate":"2021-03-12",
  "assetIdList": ["02i4x000000YzIb"],
  "moveInAccountId":"0014x00000GSjX5",
  "moveOutAccountId":"0014x00000Ds89r",
  "subaction":"assetChangeSite"
}
``` For assetChangeSite, the parameter "OrderId" is an optional parameter. If user doesn't pass the OrderId, then new Order will be created in the parent Account of moveIn Account. If no parent Account exists, then order will be created in the move Out account. The format of "moveOutDate" parameter should be YYYY-MM-DD. The API expects Ids of all assets in a bundle to be passed-in in "assetIdList" parameter.  If only some of the Ids of an Asset bundle is passed, then only the passed-in asset Ids will be considered for "Move Order" creation. It will result in incorrect "move order" behaviour.
````

Media type: `application/json`. Schema: `CreateOrderBody`.

#### Responses

*   **200** OK - API request processed. Look for messages in the response to determine if it succeeded or failed.
    
    Media type: `application/json`. Schema: `CreateCartResult`.
    
*   **400** Bad Request - Invalid subaction or Invalid Parameters

### GET Get Assets List

`GET /cpq/assets`

Operation ID: `GetAssetsList`. Tags: Assets.

Returns a list of assets  
Rest Handler - V2GetAssetsService Method Invoked - execute

#### Parameters

*   `fields` (query, array of string, collection format: csv) List of fields to return in the response, separated by commas.
    
    _Example_
    
    ```
    Id,Name
    ```
    
*   `pagesize` (query, integer) Number of records to be returned.
    
    _Example_
    
    ```
    10
    ```
    
*   `filters` (query, string) Filter field values.
    
    _Example_
    
    ```
    vlocity_cmt__AppliesTo__c:Account_Contract
    ```
    
*   `offsetSize` (query, integer) Offset from which to start reading products, for pagination.
    
    _Example_
    
    ```
    2
    ```
    
*   `sortBy` (query, string) Used to sort based on field(s).
    
    _Example_
    
    ```
    Name_DESC
    ```
    
*   `searchBy` (query, string) Used for text searching.
    
    _Example_
    
    ```
    searchBy:hello
    ```
    
*   `query` (query, string) Term used to search on result records.
    
    _Example_
    
    ```
    bundle
    ```
    

#### Responses

*   **200**
    
    OK - API request processed. Look for messages in the response to determine if it succeeded or failed.
    
    #### Get Cart Items Response Example
    
    ```json
    
        {
            "totalSize": 1,
            "actions": {
              "nexttranslation": {
                "rest": {
                  "params": {},
                  "method": "GET",
                  "link": "/services/apexrest/cmt_v102/v2/cpq/assets?pagesize=1&offsetSize=1&currentPage=2"
                },
                "remote": {
                  "params": {}
                },
                "client": {
                  "params": {}
                }
              }
            },
            "records": [{
              "displaySequence": -1,
              "Id": {
                "value": "02i4x0000001MNCAA2",
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "Asset ID",
                "hidden": true,
                "fieldName": "Id",
                "editable": false,
                "dataType": "ID",
                "alternateValues": null,
                "actions": {}
              },
              "Quantity": {
                "value": 1.00,
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "Quantity",
                "hidden": true,
                "fieldName": "Quantity",
                "editable": false,
                "dataType": "DOUBLE",
                "alternateValues": null,
                "actions": {}
              },
              "AccountId": {
                "value": "0014x00000AdQpyAAF",
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "Account ID",
                "hidden": false,
                "fieldName": "AccountId",
                "editable": false,
                "dataType": "REFERENCE",
                "alternateValues": null,
                "actions": {}
              },
              "vlocity_cmt__AssetReferenceId__c": {
                "value": "fe373aa5-d753-c7cf-aab6-b7aeaba324f0",
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "Asset Reference Id",
                "hidden": true,
                "fieldName": "vlocity_cmt__AssetReferenceId__c",
                "editable": false,
                "dataType": "STRING",
                "alternateValues": null,
                "actions": {}
              },
              "vlocity_cmt__OneTimeTotal__c": {
                "value": 246.00,
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "One Time Total",
                "hidden": true,
                "fieldName": "vlocity_cmt__OneTimeTotal__c",
                "editable": false,
                "dataType": "CURRENCY",
                "alternateValues": null,
                "actions": {}
              },
              "vlocity_cmt__LineNumber__c": {
                "value": "0001",
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "Line Number",
                "hidden": true,
                "fieldName": "vlocity_cmt__LineNumber__c",
                "editable": false,
                "dataType": "STRING",
                "alternateValues": null,
                "actions": {}
              },
              "vlocity_cmt__RootItemId__c": {
                "value": "02i4x0000001MNCAA2",
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "RootItemId",
                "hidden": true,
                "fieldName": "vlocity_cmt__RootItemId__c",
                "editable": false,
                "dataType": "STRING",
                "alternateValues": null,
                "actions": {}
              },
              "vlocity_cmt__OneTimeCharge__c": {
                "value": 82.00,
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "One Time Charge",
                "hidden": true,
                "fieldName": "vlocity_cmt__OneTimeCharge__c",
                "editable": false,
                "dataType": "CURRENCY",
                "alternateValues": null,
                "actions": {}
              },
              "vlocity_cmt__SequenceNumber__c": {
                "value": 1,
                "previousValue": null,
                "originalValue": null,
                "messages": [],
                "label": "Sequence Number",
                "hidden": true,
                "fieldName": "vlocity_cmt__SequenceNumber__c",
                "editable": false,
                "dataType": "DOUBLE",
                "alternateValues": null,
                "actions": {}
              },
              "Name": "P-10154",
              "childAssets": {
                "totalSize": 0,
                "records": [{
                  "displaySequence": -1,
                  "Id": {
                    "value": "02i4x0000001MNDAA2",
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "Asset ID",
                    "hidden": true,
                    "fieldName": "Id",
                    "editable": false,
                    "dataType": "ID",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "Quantity": {
                    "value": 1.00,
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "Quantity",
                    "hidden": true,
                    "fieldName": "Quantity",
                    "editable": false,
                    "dataType": "DOUBLE",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "AccountId": {
                    "value": "0014x00000AdQpyAAF",
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "Account ID",
                    "hidden": false,
                    "fieldName": "AccountId",
                    "editable": false,
                    "dataType": "REFERENCE",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__AssetReferenceId__c": {
                    "value": "7be2d313-c6db-648c-d100-ec54d09975d9",
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "Asset Reference Id",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__AssetReferenceId__c",
                    "editable": false,
                    "dataType": "STRING",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__OneTimeTotal__c": {
                    "value": 164.00,
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "One Time Total",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__OneTimeTotal__c",
                    "editable": false,
                    "dataType": "CURRENCY",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__LineNumber__c": {
                    "value": "0001.0001",
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "Line Number",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__LineNumber__c",
                    "editable": false,
                    "dataType": "STRING",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__RootItemId__c": {
                    "value": "02i4x0000001MNCAA2",
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "RootItemId",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__RootItemId__c",
                    "editable": false,
                    "dataType": "STRING",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__ParentItemId__c": {
                    "value": "02i4x0000001MNCAA2",
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "ParentItemId",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__ParentItemId__c",
                    "editable": false,
                    "dataType": "STRING",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__OneTimeCharge__c": {
                    "value": 82.00,
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "One Time Charge",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__OneTimeCharge__c",
                    "editable": false,
                    "dataType": "CURRENCY",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "vlocity_cmt__SequenceNumber__c": {
                    "value": 0,
                    "previousValue": null,
                    "originalValue": null,
                    "messages": [],
                    "label": "Sequence Number",
                    "hidden": true,
                    "fieldName": "vlocity_cmt__SequenceNumber__c",
                    "editable": false,
                    "dataType": "DOUBLE",
                    "alternateValues": null,
                    "actions": {}
                  },
                  "Name": "V1-10154",
                  "childAssets": {
                    "totalSize": 0,
                    "records": [{
                      "displaySequence": -1,
                      "Id": {
                        "value": "02i4x0000001MNEAA2",
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "Asset ID",
                        "hidden": true,
                        "fieldName": "Id",
                        "editable": false,
                        "dataType": "ID",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "Quantity": {
                        "value": 1.00,
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "Quantity",
                        "hidden": true,
                        "fieldName": "Quantity",
                        "editable": false,
                        "dataType": "DOUBLE",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "AccountId": {
                        "value": "0014x00000AdQpyAAF",
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "Account ID",
                        "hidden": false,
                        "fieldName": "AccountId",
                        "editable": false,
                        "dataType": "REFERENCE",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__AssetReferenceId__c": {
                        "value": "b1dd9ab7-0e46-de7c-4d54-a2ebc3e14802",
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "Asset Reference Id",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__AssetReferenceId__c",
                        "editable": false,
                        "dataType": "STRING",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__OneTimeTotal__c": {
                        "value": 82.00,
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "One Time Total",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__OneTimeTotal__c",
                        "editable": false,
                        "dataType": "CURRENCY",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__LineNumber__c": {
                        "value": "0001.0001.0001",
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "Line Number",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__LineNumber__c",
                        "editable": false,
                        "dataType": "STRING",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__RootItemId__c": {
                        "value": "02i4x0000001MNCAA2",
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "RootItemId",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__RootItemId__c",
                        "editable": false,
                        "dataType": "STRING",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__ParentItemId__c": {
                        "value": "02i4x0000001MNDAA2",
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "ParentItemId",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__ParentItemId__c",
                        "editable": false,
                        "dataType": "STRING",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__OneTimeCharge__c": {
                        "value": 82.00,
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "One Time Charge",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__OneTimeCharge__c",
                        "editable": false,
                        "dataType": "CURRENCY",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "vlocity_cmt__SequenceNumber__c": {
                        "value": 1,
                        "previousValue": null,
                        "originalValue": null,
                        "messages": [],
                        "label": "Sequence Number",
                        "hidden": true,
                        "fieldName": "vlocity_cmt__SequenceNumber__c",
                        "editable": false,
                        "dataType": "DOUBLE",
                        "alternateValues": null,
                        "actions": {}
                      },
                      "Name": "C1-10154"
                    }
                    ]
                  }
                }
                ]
              }
            }
            ]
          }
          
        
    ```
    

### GET Get Cart Summary

`GET /cpq/carts/{cartid}`

Operation ID: `Get Cart Summary`. Tags: Cart.

Returns a summary representation of the cart including: + Pricing information, such as total one-time charge and total recurring charge + Account information associated with this cart + If this cart includes a multisite order, available sites + Links to further actions, such as _check out_ Rest Handler - CpqCreateCartActionV2 Method Invoked - getCarts

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `validate` (query, boolean) Indicates whether validation rules are run for the current API request (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    
*   `price` (query, boolean) Indicates whether to run the pricing engine (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    
*   `headerFieldSet` (query, string) Name of a Salesforce Field Set defined for the given cart object (Opportunity, Quote, Order) which identifies the fields to return in the response. Omitting this parameter will return all fields from the cart object except the following fields: IsDeleted, CreatedDate, CreatedById, LastModifiedDate, LastModifiedById, SystemModstamp, LastActivityDate, CleanStatus.
    
    _Example_
    
    ```
    fieldSetFeature
    ```
    
*   `translation` (query, boolean) to get translated labels, default is true (CMT 101)
    
    _Example_
    
    ```
    true
    ```
    

#### Responses

*   **200** OK - API request processed. Look for messages in the response to determine if it succeeded or failed.
    
    Media type: `application/json`. Schema: `CartResult`.
    

### PUT Update Cart Summary

`PUT /cpq/carts/{cartid}`

Operation ID: `UpdateCartSummary`. Tags: Cart.

Update the cart summary. Rest Handler - APICartsCpqV2. Method Invoked - updateCarts

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    

#### Request body (required)

Request Body with input fields.

#### Update Cart Request Example

```json

{
    "inputFields":[
     {  "Pricebook2Id":"01s6A000002Y7wz"  },
    ],
    "fields":"Id,Name"
}

```

Media type: `application/json`. Schema: `UpdateCartBody`.

#### Responses

*   **200** OK - API request processed. Look for messages in the response to determine if it succeeded or failed.

### GET Get Filterable Attributes

`GET /cpq/carts/{cartid}/attributes`

Operation ID: `GetFilterableAttributes`. Tags: Cart.

Return the filterable attributes that are applicable for this cart, including Product attributes. The Product attribute values that the customer can choose to filter Products Rest Handler - APICartsAttributesCpqV2 Method Invoked - getCartsAttributes

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    

#### Responses

*   **200** Return the filterable attributes that are applicable for this cart
    
    Media type: `application/json`. Schema: `CartAttributeDetail`.
    

### POST Runs validation and pricing for the items in the cart.

`POST /cpq/carts/{cartid}/validate`

Operation ID: `validate-POST`. Tags: Cart.

Runs validation and pricing for the items in the cart.

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `price` (query, boolean) Indicates whether to run the pricing engine (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    
*   `validate` (query, boolean) Indicates whether validation rules are run for the current API request (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    

#### Request body

Request Body with cartId - required

#### Validate Cart Request Example

```json
{
  "cartId":"8011N00000157LkQAI",
  "methodName":"runCartValidation",
  "price":true,
  "validate":true
  }
```

Media type: `application/json`. Schema: `ValidateCartBody`.

#### Responses

*   **200** OK - API request processed. Look for messages in the response to determine if it succeeded or failed. Rest Handler - validate Method Invoked - runCartValidation
    
    Media type: `application/json`. Schema: `ValidateCartResponse`.
    

### GET Get Cart Items

`GET /cpq/carts/{cartid}/items`

Operation ID: `Get Cart Items`. Tags: Cart.

Get a representation of the items in a specified cart. Rest Handler - APIItemsCartsCpqV2 Method Invoked - getCartsItems

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `query` (query, string) Search text
    
    _Example_
    
    ```
    iphone+6s
    ```
    
*   `id` (query, string) List of comma separated itemIds to return only the corresponding cart Items
    
    _Example_
    
    ```
    01u41000001QPtsAAG
    ```
    
*   `lastRecordId` (query, string) The last record ID from the previous search result, if available.
    
    _Example_
    
    ```
    01uf4000001q1W3AAI
    ```
    
*   `pagesize` (query, integer) Number of records to be returned.
    
    _Example_
    
    ```
    10
    ```
    
*   `hierarchy` (query, integer) Specifies product hierarchy.
    
    _Example_
    
    ```
    2
    ```
    
*   `includeAttachment` (query, boolean) Indicates whether product attachments are returned (true) or not (false).
    
    _Example_
    
    ```
    true
    ```
    
*   `fields` (query, array of string, collection format: csv) List of fields to return in the response, separated by commas.
    
    _Example_
    
    ```
    Id,Name
    ```
    
*   `filter` (query, string) Filter field values.
    
    _Example_
    
    ```
    vlocity_cmt__ServiceAccountId__c:991360000008eNU_991360000008eNY
    ```
    
*   `price` (query, boolean) Indicates whether to run the pricing engine (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    
*   `validate` (query, boolean) Indicates whether validation rules are run for the current API request (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    

#### Responses

*   **200**
    
    OK - API request processed. Look for messages in the response to determine if it succeeded or failed.
    
    #### Get Cart Items Response Example
    
    ```json
          {
            "totalSize": 1,
            "messages": [],
            "records": [{
              "messages": [],
                "actions": {
                "addtocart": {
                      "rest": {
                          "params": {
                          "includeAttachment": false,
                          "pagesize": 5,
                          "lastRecordId": null,
                          "hierarchy": 0,
                          "query": null,
                          "itemId": "01u41000001QPtsAAG"
                        }]
                      },
                  "method": "POST",
                  "link": "/services/apexrest/vlocity_cmt__/v2/cpq/carts/80141000000Cg8HAAS/items"
                  },
          "remote": {
              "params": {
                "price": true,
                "validate": true,
                "includeAttachment": false,
                "pagesize": 10
                "lastRecordId": null,
                "hierarchy": 0,
                "query": null,
              "items": [{
                "parentId": "80241000000HalcAAC",
                "quantity": 1,
                "itemId": "01u41000001QPtsAAG"
                }],
                "cartId": "80141000000Cg8HAAS",
              "methodName": "postCartsItems"
                }
              },
          "client": {
            "params": {}
                }
              },
          "updateitems": {
              "rest": {
                  "params": {
                  "fields": null,
                  "price": true,
                  "validate": true,
                  "filters": null,
                  "hierarchy": 0,
                  "includeAttachment": false,
                  "pagesize": 5,
                  "lastRecordId": null,
                  "query": null,
                  "items": [{
                    "itemId": "80241000000HalcAAC"
                    }]
                },
              "method": "PUT",
              "link": "/services/apexrest/vlocity_cmt__/v2/cpq/carts/80141000000Cg8HAAS/items"
                },
            "remote": {
                "params": {
                "fields": null,
                "price": true,
                "validate": true,
                "filters": null,
                "hierarchy": 0,
                "includeAttachment": false,
                "pagesize": 5,
                "lastRecordId": null,
                "query": null,
                  "items": [{
                    "itemId": "80241000000HalcAAC"
                    }],
                  "cartId": "80141000000Cg8HAAS",
                  "methodName": "putCartsItems"
                  }
                },
              "client": {
                  "params": {}
    
              }
    },
          "displaySequence": -1,
          "Id": {
            "value": "80241000000HalcAAC",
            "messages": [],
            "label": "Order Product ID",
            "hidden": false,
            "fieldName": "Id",
            "editable": false,
            "dataType": "ID",
            "actions": {}
              },
          "Pricebook2Id": "01s41000005dPYQAA2",
          "Product2Id": "01t41000000sYaSAAU",
          "UnitPrice": {
              "value": 1.00,
              "messages": [],
              "label": "Unit Price",
              "hidden": false,
              "fieldName": "UnitPrice",
              "editable": true,
              "dataType": "CURRENCY",
              "actions": {}
    
          },
          "Name": "GC 2",
          "IsActive": true,
          "Product2": {
          "attributes": {
              "type": "Product2",
              "url": "/services/data/v38.0/sobjects/Product2/01t41000000sYaSAAU"
            },
          "Id": "01t41000000sYaSAAU",
          "Name": "GC 2",
          "vlocity_cmt__IsConfigurable__c": false,
          "vlocity_cmt__Type__c": "None",
          "vlocity_cmt__SubType__c": "None",
          "RecordTypeId": "012410000006OWUAA2",
          "vlocity_cmt__JSONAttribute__c": null
          },
          "productId": "01t41000000sYaSAAU",
          "defaultQuantity": 1.0,
          "minQuantity": 0.0,
          "maxQuantity": 99999.0,
          "groupMinQuantity": 0,
          "groupMaxQuantity": 99999,
          "sequenceNumber": 1.00,
          "productChildItemDefinition": {
              "attributes": {
                  "type": "vlocity_cmt__ProductChildItem__c",
                  "url": "/services/data/v38.0/sobjects/vlocity_cmt__ProductChildItem__c/a2541000000G0AGAA0"
                },
          "Id": "a2541000000G0AGAA0",
          "Name": "Root PCI",
          "vlocity_cmt__IsVirtualItem__c": false,
          "vlocity_cmt__Quantity__c": 1,
          "vlocity_cmt__MaxQuantity__c": 99999,
          "vlocity_cmt__MinQuantity__c": 0,
          "vlocity_cmt__MaximumChildItemQuantity__c": 99999,
          "vlocity_cmt__MinimumChildItemQuantity__c": 0,
          "vlocity_cmt__IsOverride__c": false,
          "vlocity_cmt__ParentProductId__c": "01t41000000sYaSAAU",
          "vlocity_cmt__ChildLineNumber__c": "1",
          "vlocity_cmt__SeqNumber__c": 1.00,
          "vlocity_cmt__CollapseHierarchy__c": false,
          "vlocity_cmt__IsRootProductChildItem__c": true,
          "vlocity_cmt__ParentProductId__r": {
              "attributes": {
                  "type": "Product2",
                  "url": "/services/data/v38.0/sobjects/Product2/01t41000000sYaSAAU"
                },
          "Id": "01t41000000sYaSAAU",
          "Name": "GC 2"
            }
          },
          "productHierarchyPath":"01t41000000sYaSAAU",
          "name": "GC 2",
          "isVirtualItem": false,
          "itemType": "lineItem",
          "PricebookEntryId": {
              "value": "01u41000001QPtsAAG",
              "messages": [],
              "label": "Price Book Entry ID",
              "hidden": false,
              "fieldName": "PricebookEntryId",
              "editable": false,
              "dataType": "REFERENCE",
            "actions": {}
            },
          "Quantity": {
              "value": 1.00,
              "messages": [],
    
            "label": "Quantity",
            "hidden": false,
            "fieldName": "Quantity",
            "editable": true,
            "dataType": "DOUBLE",
            "actions": {}
            },
    
          "vlocity_cmt__OneTimeTotal__c": {
              "value": 1.00,
              "messages": [],
              "label": "One Time Total",
              "hidden": false,
              "fieldName": "vlocity_cmt__OneTimeTotal__c",
              "editable": false,
              "dataType": "CURRENCY",
              "actions": {}
            },
            "vlocity_cmt__SupplementalAction__c": {
              "value": "Amend"
              "messages": [],
              "label": "Supplemental Action",
              "hidden": false,
              "fieldName": "vlocity_cmt__SupplementalAction__c",
              "editable": true,
              "dataType": "REFERENCE",
              "actions": {}
            },
          "vlocity_cmt__RecurringTotal__c": {
              "value": 0.00,
              "messages": [],
              "label": "Recurring Total",
              "hidden": false,
              "fieldName": "vlocity_cmt__RecurringTotal__c",
              "editable": false,
              "dataType": "CURRENCY",
    
              "actions": {}
    
          },
          "vlocity_cmt__OneTimeCharge__c": {
              "value": 1.00,
              "messages": [],
              "label": "One Time Charge",
              "hidden": false,
              "fieldName": "vlocity_cmt__OneTimeCharge__c",
              "editable": false,
              "dataType": "CURRENCY",
              "actions": {}
            },
          "vlocity_cmt__OneTimeCalculatedPrice__c": {
              "value": 1.00,
              "messages": [],
              "label": "One Time Calculated Price",
              "hidden": false,
              "fieldName": "vlocity_cmt__OneTimeCalculatedPrice__c",
              "editable": true,
              "dataType": "CURRENCY",
              "actions": {}
            },
          "vlocity_cmt__OneTimeManualDiscount__c": {
                "value": 0.00,
                "messages": [],
                "label": "One Time Manual Discount",
                "hidden": false,
                "fieldName": "vlocity_cmt__OneTimeManualDiscount__c",
                "editable": true,
                "dataType": "PERCENT",
                "actions": {}
            },
            "vlocity_cmt__RecurringCharge__c": {
                "value": 0.00,
                "messages": [],
                "label": "Recurring Charge",
                "hidden": false,
                "fieldName": "vlocity_cmt__RecurringCharge__c",
                "editable": false,
                "dataType": "CURRENCY",
                "actions": {}
              },
    
            "vlocity_cmt__RecurringCalculatedPrice__c": {
                  "value": 0.00,
                  "messages": [],
                  "label": "Recurring Calculated Price",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__RecurringCalculatedPrice__c",
                  "editable": true,
                  "dataType": "CURRENCY",
                "actions": {}
              },
            "vlocity_cmt__RecurringManualDiscount__c": {
                  "value": 0.00,
                  "messages": [],
                  "label": "Recurring Manual Discount",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__RecurringManualDiscount__c",
                  "editable": true,
                  "dataType": "PERCENT",
                  "actions": {}
              },
            "PricebookEntry": {
                  "attributes": {
                  "type": "PricebookEntry",
                  "url": "/services/data/v38.0/sobjects/PricebookEntry/01u41000001QPtsAAG"
                    },
                "Id": "01u41000001QPtsAAG",
                "Product2Id": "01t41000000sYaSAAU",
                "Pricebook2Id": "01s41000005dPYQAA2",
                "Product2": {
                  "attributes": {
                      "type": "Product2",
                      "url": "/services/data/v38.0/sobjects/Product2/01t41000000sYaSAAU"
                  },
                  "Id": "01t41000000sYaSAAU",
                  "Name": "GC 2",
                  "vlocity_cmt__Type__c": "None",
                  "vlocity_cmt__IsConfigurable__c": false
                }
            },
              "vlocity_cmt__ServiceAccountId__r": {
                    "attributes": {
                      "type": "Account",
                      "url": "/services/data/v38.0/sobjects/Account/00141000007uyWYAAY"
                      },
                    "Id": "00141000007uyWYAAY",
                    "Name": "telus test"
                    },
    
              "vlocity_cmt__BillingAccountId__r": {
                    "attributes": {
                    "type": "Account",
                    "url": "/services/data/v38.0/sobjects/Account/00141000007uyWYAAY"
                      },
                    "Id": "00141000007uyWYAAY",
                    "Name": "telus test"
                    },
                "vlocity_cmt__InCartQuantityMap__c": {
                  "value": null,
                  "messages": [],
                  "label": "InCartQuantityMap",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__InCartQuantityMap__c",
                  "editable": true,
                  "dataType": "TEXTAREA",
                  "actions": {}
                    },
                "vlocity_cmt__JSONAttribute__c": {
                    "value": null,
                    "messages": [],
                    "label": "JSONAttribute",
                    "hidden": false,
                    "fieldName": "vlocity_cmt__JSONAttribute__c"
                    "editable": true,
                    "dataType": "TEXTAREA",
                    "actions": {}
                }
              }]
              }
        ```
    ```
    

### PUT Update Item(s) in a Cart

`PUT /cpq/carts/{cartid}/items`

Operation ID: `Update Items in a Cart`. Tags: Cart.

Update one or more items in a specified cart. Rest Handler - APIItemsCartsCpqV2 Method Invoked - putCartsItems

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    

#### Request body

Request Body with input fields

#### Update Items in Cart Request Example

```json
  {
          "items": {
            "records": [
              {
                "attributeCategories": {
                  "totalSize": 0,
                  "records": [
                    {
                      "displaySequence": 7879,
                      "Code__c": "CATEGORY_CODE-78231",
                      "id": "a0K1I000002VwDEUA0",

                      "productAttributes": {

                        "totalSize": 0,

                        "records": [

                          {

                            "code": "CODE-70207",

                            "dataType": "number",

                            "inputType": "number",

                            "required": false,

                            "readonly": false,

                            "disabled": false,

                            "filterable": true,

                            "attributeId": "a0L1I00000107vJUAQ",

                            "label": "ATTRIBUTE-54063",

                            "displaySequence": -1,

                            "userValues": "9",

                            "min": 0,

                            "max": 0,

                            "values": [

                              {

                                "readonly": false,

                                "disabled": false

                              }

                            ]

                          }

                        ]

                      },

                      "Name": "ATTRIBUTE_CATEGORY-41131"

                    }

                  ]

                },

                "PricebookEntry": {

                  "Product2Id": "01t1I000001Q9PIQA0",

                  "Pricebook2Id": "01s1I000006oNmAQAU",

                  "Id": "01u1I000001sNdiQAE",

                  "Product2": {

                    "Name": "PRODUCT-68097",

                    "Id": "01t1I000001Q9PIQA0",

                    "vlocity_cmt__Type__c": "None",

                    "vlocity_cmt__IsConfigurable__c": "false"

                  }

                }

              }

            ]

          }

        }

```

Media type: `application/json`. Schema: `ValidateCartResponse`.

#### Responses

*   **200**
    
    OK - API request processed. Look for messages in the response to determine if it succeeded or failed.
    
    #### Update Cart Items response
    
    ```json
    
      {
      "totalSize": 1,
      "messages": [
        {
          "code": "161",
          "severity": "INFO",
          "message": "Attributes modified successfully."
        }
      ],
      "records": [
        {
          "messages": [
          ],
          "displaySequence": -1,
          "PricebookEntry": {
            "Product2Id": "01t1I000001Q9PIQA0",
            "Pricebook2Id": "01s1I000006oNmAQAU",
            "Id": "01u1I000001sNdiQAE",
            "Product2": {
              "vlocity_cmt__IsConfigurable__c": "false",
              "vlocity_cmt__Type__c": "None",
              "Id": "01t1I000001Q9PIQA0",
              "Name": "PRODUCT-68097"
            }
          },
          "attributeCategories": {
            "totalSize": 1,
            "messages": [
            ],
            "records": [
              {
                "messages": [
                ],
                "displaySequence": 7879,
                "Code__c": "CATEGORY_CODE-78231",
                "Name": "ATTRIBUTE_CATEGORY-41131",
                "id": "a0K1I000002VwDEUA0",
                "productAttributes": {
                  "totalSize": 3,
                  "messages": [
                  ],
                  "records": [
                    {
                      "messages": [
                      ],
                      "code": "CODE-77007",
                      "dataType": "number",
                      "inputType": "number",
                      "required": true,
                      "readonly": false,
                      "disabled": false,
                      "filterable": true,
                      "attributeId": "a0L1I00000107vOUAQ",
                      "label": "ATTRIBUTE-29707",
                      "displaySequence": -1,
                      "hasRules": true,
                      "hidden": false,
                      "values": [
                        {
                          "readonly": false,
                          "disabled": false
                        }
                      ],
                      "userValues": null
                    },
                    {
                      "messages": [
                      ],
                      "code": "CODE-70207",
                      "dataType": "number",
                      "inputType": "number",
                      "required": false,
                      "readonly": false,
                      "disabled": false,
                      "filterable": true,
                      "attributeId": "a0L1I00000107vJUAQ",
                      "label": "ATTRIBUTE-54063",
                      "displaySequence": -1,
                      "hasRules": true,
                      "hidden": false,
                      "values": [
                        {
                          "readonly": false,
                          "disabled": false,
                          "value": 9
                        }
                      ],
                      "userValues": 9
                    },
                    {
                      "messages": [
                      ],
                      "code": "CODE-40063",
                      "dataType": "number",
                      "inputType": "number",
                      "required": false,
                      "readonly": false,
                      "disabled": false,
                      "filterable": true,
                      "attributeId": "a0L1I00000107vTUAQ",
                      "label": "ATTRIBUTE-77042",
                      "displaySequence": -1,
                      "hasRules": true,
                      "hidden": false,
                      "values": [
                        {
                          "readonly": false,
                          "disabled": false
                        }
                      ],
                      "userValues": null
                    }
                  ]
                }
              }
            ]
          }
        }
      ]
    }
    
          
        
    ```
    

### POST Add Item(s) to a Cart

`POST /cpq/carts/{cartid}/items`

Operation ID: `Add Items to a Cart`. Tags: Cart.

Add one or more items to a specified cart.

*   Rest Handler
    
    *   APIItemsCartsCpqV2 Method Invoked - postCartsItems
*   Spring 2020 enhancements (see examples below)
    
    *   Additional support for Multi Add/delete of Root & child items
        
    *   **noResponseNeeded** (set to **true**) will return just success or failure
        

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `itemId` (path, string, required) Line Item ID under the cart.
    
    _Example_
    
    ```
    80236000009E2InAAK
    ```
    
*   `price` (query, boolean) Indicates whether to run the pricing engine (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    
*   `validate` (query, boolean) Indicates whether validation rules are run for the current API request (true) or not (false).  
    Default: `true`.
    
    _Example_
    
    ```
    true
    ```
    
*   `hierarchy` (query, integer) Specifies product hierarchy.
    
    _Example_
    
    ```
    2
    ```
    
*   `pagesize` (query, integer) Number of records to be returned.
    
    _Example_
    
    ```
    10
    ```
    
*   `includeAttachment` (query, boolean) Indicates whether product attachments are returned (true) or not (false).
    
    _Example_
    
    ```
    true
    ```
    
*   `expandAll` (query, boolean) Specifies level of hierarchy for assets.
    
    _Example_
    
    ```
    false
    ```
    
*   `fields` (query, array of string, collection format: csv) List of fields to return in the response, separated by commas.
    
    _Example_
    
    ```
    Id,Name
    ```
    

#### Request body

Request Body with input fields

#### Add Items to a Cart Request Example

```json
  {
              "items": [{
              "itemId": "01uf4000000gmRTAAY",
              "parentId": "802f4000000PZ1VAAW",
              "parentRecord": {
                  "records": [{
                  "messages": [
                      ],
                  "displaySequence": -1,
                  "Id": {
                        "messages": [ ],
                        "label": "Order Product ID",
                        "hidden": false,
                        "fieldName": "Id",
                        "editable": false,
                        "dataType": "ID",
                        "value": "802f4000000PZ1VAAW"
                      },
                    "UnitPrice": {
                    "messages": [ ],
                    "label": "Unit Price",
                    "hidden": true,
                    "fieldName": "UnitPrice",
                    "editable": false,
                    "dataType": "CURRENCY",
                    "value": 358.95
                      },
                    "productId": "01tf4000000Kd0uAAC",
                      "defaultQuantity": 1,
                      "minQuantity": 0,
                      "maxQuantity": 99999,
                      "groupMinQuantity": 0,
                      "groupMaxQuantity": 99999,
                      "sequenceNumber": 1,
                      "productHierarchyPath": "01tf4000000Kd0uAAC",
                      "itemType": "lineItem",
                      "childProducts": {
                      "records": [{
                              "Name": {
                              "label": "Product Name",
                              "value": "PRODUCT-77151"
                        },
                        "UnitPrice": {
                        "label": "List Price",
                        "value": 0.0
                        },
                        "vlocity_cmt__RecurringPrice__c": {
                          "label": "Recurring Price",
                          "value": 0.0
                        },
                        "Product2Id": {
                          "label": "Product ID",
                          "value": "01tf4000000Kd0zAAC"
                        },
                        "Pricebook2Id": {
                          "label": "Price Book ID",
                          "value": "01sf4000003LYn3AAG"
                        },
                        "Id": {
                          "label": "Price Book Entry ID",
                          "value": "01uf4000000gmRTAAY"
                        },
                        "defaultQuantity": 0,
                        "productId": "01tf4000000Kd0zAAC",
                        "Product2": {
                        "Name": "PRODUCT-77151",
                        "RecordTypeId": "012f40000004zEOAAY",
                        "vlocity_cmt__IsConfigurable__c": false,
                        "vlocity_cmt__SubType__c": "None",
                        "vlocity_cmt__Type__c": "None"
                        },
                        "messages": [ ],
                        "actions": {
                            "addtocart": {
                            "rest": {
                                    "params": {
                                    "price": true,
                                    "validate": true,
                                    "includeAttachment": false,
                                    "pagesize": 20,
                                    "hierarchy": -1,
                                    "items": [{
                                    "parentId": "802f4000000PZ1VAAW",
                                    "quantity": 0,
                                    "itemId": "01uf4000000gmRTAAY"
                            }],
                          "cartId": "801f4000000ChZjAAK"
                            },
                          "method": "POST",
                          "link": "/services/apexrest/vlocity_cmt/v2/cpq/carts/801f4000000ChZjAAK/items"
                          },
                        "remote": {
                            "params": {
                            "price": true,
                            "validate": true,
                            "includeAttachment": false,
                            "pagesize": 20,
                            "hierarchy": -1,
                            "items": [{
                                    "parentId": "802f4000000PZ1VAAW",
                                    "quantity": 0,
                                    "itemId": "01uf4000000gmRTAAY"
                                }],
                                "cartId": "801f4000000ChZjAAK",
                                "methodName": "postCartsItems"
                            }
                          },
                        "client": {
                            "params": {
                                "pagesize": 0,
                                "hierarchy": 0
                            }
                          }
                        }
                      }
                    }]
                  },
              "vlocity_cmt__RecurringPrice__c": 527.96,
              "name": "PRODUCT-39982",
              "provisioningStatus": "New",
              "Product2Id": "01tf4000000Kd0uAAC",
              "PricebookEntryId": {
                  "messages": [ ],
                  "label": "Price Book Entry ID",
                  "hidden": false,
                  "fieldName": "PricebookEntryId",
                  "editable": false,
                  "dataType": "REFERENCE",
                  "value": "01uf4000000gmRJAAY"
                },
              "Quantity": {
                  "messages": [ ],
                  "label": "Quantity",
                  "hidden": false,
                  "fieldName": "Quantity",
                  "editable": true,
                  "dataType": "DOUBLE",
                  "value": 1
              },
              "vlocity_cmt__OneTimeTotal__c": {
                  "messages": [ ],
                  "label": "One Time Total",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__OneTimeTotal__c",
                  "editable": false,
                  "dataType": "CURRENCY",
                  "value": 358.95
              },
              "vlocity_cmt__RecurringTotal__c": {
                  "messages": [ ],
                  "label": "Recurring Total",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__RecurringTotal__c",
                  "editable": false,
                  "dataType": "CURRENCY",
                  "value": 527.96
              },
              "vlocity_cmt__OneTimeCharge__c": {
                  "messages": [ ],
                  "label": "One Time Charge",
                  "hidden": true,
                  "fieldName": "vlocity_cmt__OneTimeCharge__c",
                  "editable": false,
                  "dataType": "CURRENCY",
                  "value": 358.95
              },
              "vlocity_cmt__RecurringCharge__c": {
                  "messages": [ ],
                  "label": "Recurring Charge",
                  "hidden": true,
                  "fieldName": "vlocity_cmt__RecurringCharge__c",
                  "editable": false,
                  "dataType": "CURRENCY",
                  "value": 527.96
              },
              "vlocity_cmt__RecurringManualDiscount__c": {
                  "messages": [ ],
                  "label": "Recurring Manual Discount",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__RecurringManualDiscount__c",
                  "editable": true,
                  "dataType": "PERCENT",
                  "value": 0.0
              },
              "vlocity_cmt__OneTimeManualDiscount__c": {
                  "messages": [ ],
                  "label": "One Time Manual Discount",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__OneTimeManualDiscount__c",
                  "editable": true,
                  "dataType": "PERCENT",
                  "value": 0.0
              },
              "PricebookEntry": {
                  "Product2Id": "01tf4000000Kd0uAAC",
                  "Pricebook2Id": "01sf4000003LYn3AAG",
                  "Id": "01uf4000000gmRJAAY",
                  "Product2": {
                    "Name": "PRODUCT-39982",
                    "Id": "01tf4000000Kd0uAAC",
                    "vlocity_cmt__Type__c": "None",
                    "vlocity_cmt__IsConfigurable__c": "false"
                  }
              },
              "Product2": {
                  "Name": "PRODUCT-39982",
                  "RecordTypeId": "012f40000004zEOAAY",
                  "vlocity_cmt__IsConfigurable__c": false,
                  "vlocity_cmt__SubType__c": "None",
                  "vlocity_cmt__Type__c": "None"
              },
              "vlocity_cmt__ItemName__c": {
                  "messages": [ ],
                  "label": "Item Name",
                  "hidden": false,
                  "fieldName": "vlocity_cmt__ItemName__c",
                  "editable": true,
                  "dataType": "STRING"
              },
              "actions": {
                  "addtocart": {
                      "rest": {
                        "params": {
                          "price": true,
                          "validate": true,
                          "includeAttachment": false,
                          "pagesize": 20,
                          "hierarchy": -1,
                          "items": [{
                              "parentId": "802f4000000PZ1VAAW",
                              "quantity": 1,
                              "itemId": "01uf4000000gmRJAAY"
                              }],
                        "cartId": "801f4000000ChZjAAK"
                        },
                      "method": "POST",
                      "link": "/services/apexrest/vlocity_cmt/v2/cpq/carts/801f4000000ChZjAAK/items"
                    },
                  "remote": {
                      "params": {
                        "price": true,
                        "validate": true,
                        "includeAttachment": false,
                        "pagesize": 20,
                        "hierarchy": -1,
                        "items": [{
                        "parentId": "802f4000000PZ1VAAW",
                        "quantity": 1,
                        "itemId": "01uf4000000gmRJAAY"
                          }],
                        "cartId": "801f4000000ChZjAAK",
                        "methodName": "postCartsItems"
                      }
                    },
                  "client": {
                      "params": {
                      "pagesize": 0,
                      "hierarchy": 0
                      }
                    }
                  },
                },
              }],
            },
    }]
          "hierarchy": 0,
          "pagesize": 0,
          "levelBasedApproach": false
}
```

#### Multi ROOT Item Add Example

Comma separated string should be passed as _itemId_ to support MultiAdd enhancement eg

```json
{
  "items": [
    {
      "itemId": "01uf400000HY8YuAAL,01uf400000HY8YkAAL"
    }
  ]
}
```

#### Multi ROOT Item add example with NoResponse parameter

*   Comma separated string should be passed as **itemId** to support MultiAdd enhancement
*   **noResponseNeeded** set to **true**

```json
{
  "noResponseNeeded": true,

  "items": [
    {
      "itemId": "01uf400000HY8YuAAL,01uf400000HY8YkAAL"
    }
  ]
}
```

#### Sample response with noResponseNeeded parameter

```json
{
  "totalSize": 0,
  "messages": [
    {
      "code": "150",
      "severity": "INFO",
      "message": "Successfully added."
    }
  ],
  "actions": {
    "itempricesupdated": {
      "rest": {
        "params": {},
        "method": "GET",
        "link": "/services/apexrest/h_cpq_daily/v2/cpq/carts/801f4000006lI3pAAE/price?price=false"
      },
      "remote": {
        "params": {
          "price": false,
          "cartId": "801f4000006lI3pAAE",
          "methodName": "getCartLineItemPrices"
        }
      },
      "client": {
        "params": {}
      }
    }
  }
}            
```

#### Multi CHILD Item Add Example

Comma separated string should be passed as _itemId_ to support MultiAdd enhancement

```json
    {
      "items": [
        {
          "parentId": "802f400000YzH8WAAV",
          "parentHierarchyPath": "01tf4000004ULpJAAW<01tf4000004ULpOAAW<01tf4000004ULpYAAW<01tf4000004ULpiAAG",
          "itemId": "01uf400000HY8YGAA1,01uf400000HY8YuAAL,01uf400000HY8YkAAL",
          "parentRecord": {
            "records": [
              {
                "Id": "01tf4000004ULpiAAG",
                "productId": "01tf4000004ULpiAAG",
                "productHierarchyPath": "01tf4000004ULpJAAW<01tf4000004ULpOAAW<01tf4000004ULpYAAW<01tf4000004ULpiAAG",
                "itemType": "productGroup",
                "parentLineItemId": "802f400000YzH8WAAV"
              }
            ]
          }
        }
      ]
    }            
```

#### Multi CHILD Item Add Example with NoResponse parameter

*   Comma separated string should be passed as **itemId** to support MultiAdd enhancement
*   **noResponseNeeded** set to **true**

```json
{
  "noResponseNeeded": true,

  "items": [
    {
      "parentId": "802f400000YzH8WAAV",
      "parentHierarchyPath": "01tf4000004ULpJAAW<01tf4000004ULpOAAW<01tf4000004ULpYAAW<01tf4000004ULpiAAG",
      "itemId": "01uf400000HY8YGAA1,01uf400000HY8YuAAL,01uf400000HY8YkAAL",
      "parentRecord": {
        "records": [
          {
            "Id": "01tf4000004ULpiAAG",
            "productId": "01tf4000004ULpiAAG",
            "productHierarchyPath": "01tf4000004ULpJAAW<01tf4000004ULpOAAW<01tf4000004ULpYAAW<01tf4000004ULpiAAG",
            "itemType": "productGroup",
            "parentLineItemId": "802f400000YzH8WAAV"
          }
        ]
      }
    }
  ]
}            
```

Media type: `application/json`. Schema: `ValidateCartResponse`.

#### Responses

*   **200** OK - API request processed. Look for messages in the response to determine if it succeeded or failed.

### GET Get Applied or Available Promotions for a Cart

`GET /cpq/carts/{cartid}/promotions`

Operation ID: `Get Applied Promotions`. Tags: Cart.

Promotions give a cart beneficial pricing or other benefits. A given cart for a given customer will only have certain promotions available to be applied to the cart. A cart can also already have one or more promotions applied. This GET operation will retrieve any promotions applied or available to the given cart. In different circumstances, qualification, penalty and evaluation rules are applied to promotions and the usage of the rules depends on the parameters set.

**Sub Action** - By default (when _subaction=..._ is omitted from the request) this operation returns the list of promotions that are available to be applied to the given cart. Add the _subaction=getPromotionsAppliedToCart_ query parameter to instead request the list of promotions that are currently applied to the cart.

*   **subaction=getPromotionsAppliedToCart** - Return promotions currently applied to the cart. If an evaluation ruleset is applied then this method returns the qualified promotions based on the data provided in the ruelEvalautionInput parameter.
*   **subaction parameter omitted** - Return promotions that are available to be applied to the cart

**include** - By default the qualifications for each promotion are not returned in the response because they take time to calculate. Add the _include=qualifications_ query parameter to request a list of required qualifications for each promotion and which are satisfied or not satisfied. If the _include=_ parameter is omitted, the _category_ fields and _qualifications_ arrays will not be returned in the response.

Rest Handler - APIPromotionsCartsCpqV2 Method Invoked - getCartsPromotions

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `subaction` (query, string) An optional subaction that switches what data is returned from the request.  
    Allowed values: `getPromotionsAppliedToCart`.
*   `include` (query, string) Optional components to include in the response. Currently only _qualifications_.  
    Allowed values: `qualifications`.
*   `includePenalties` (query, boolean) whether to return the penalties for the promotions in the result or not
    
    _Example_
    
    ```
    true
    ```
    
*   `ruleType` (query, string) Indicates which type of context rule to run. This should be used when we have includes param as qualifications or evaluation
    
    _Example_
    
    ```
    evaluation
    ```
    
*   `ruleEvaluationInput` (query, string) The input to be used in the evaluation of context rules and it allows you to provide temporary values at run-time to determine if acustomer is eligible for a promotion without changing the actual values stored in Salesforce. Also, the format for the input should describe the sObject, the field and the temporary value that should be evaluated in JSON notation
    
    _Example_
    
    ```
    {
      "Order": {
        "OriginatingChannel__c": "Web"
      }
    }
    ```
    
*   `filters` (query, string) Filter field values.
    
    _Example_
    
    ```
    vlocity_cmt__AppliesTo__c:Account_Contract
    ```
    
*   `category` (query, string) Category to which the product belongs.
    
    _Example_
    
    ```
    Qualified, Disqualified
    ```
    
*   `fields` (query, array of string, collection format: csv) List of fields to return in the response, separated by commas.
    
    _Example_
    
    ```
    Id,Name
    ```
    
*   `pagesize` (query, integer) Number of records to be returned.
    
    _Example_
    
    ```
    10
    ```
    
*   `commitmentDateFilter` (query, string) Filters active applied promotions based on this date.
    
    _Example_
    
    ```
    2017-04-05T07:00:00.000Z
    ```
    
*   `appliedPromoStatusFilter` (query, string) Filter to specific the kind of applied promotions to be retrieved.
    
    _Example_
    
    ```
    Active
    ```
    

#### Responses

*   **200**
    
    |
    
    Response
    
    #### Get Applied Promotions for Cart Response
    
    ```json
       "totalSize": 1,
       "messages": [],
       "records": [{
         "messages": [],
         "actions": {
           "deleteappliedpromoitems": {
             "rest": {
               "params": {},
               "method": "DELETE",
               "link": "/services/apexrest/vlocity_cmt/v2/cpq/carts/801f40000008UlxAAE/promotions?id=a2Lf4000000TvFmEAK"
             },
             "remote": {
               "params": {
                 "id": "a2Lf4000000TvFmEAK",
                 "cartId": "801f40000008UlxAAE",
                 "methodName": "deleteAppliedPromoItems"
               }
             },
             "client": {
               "params": {}
             }
           },
           "getpromodetails": {
             "rest": {
               "params": {},
               "method": "GET",
               "link": "/services/apexrest/vlocity_cmt/v2/cpq/carts/801f40000008UlxAAE/promotions?id=a2Lf4000000TvFmEAK&subaction=getPromotionsAppliedToCart&includePenalties=true"
             },
             "remote": {
               "params": {
                 "includePenalties": true,
                 "subaction": "getPromotionsAppliedToCart",
                 "id": "a2Lf4000000TvFmEAK",
                 "cartId": "801f40000008UlxAAE",
                 "methodName": "getPromotionsAppliedToCart"
               }
             },
             "client": {
               "params": {}
             }
           }
         },
         "displaySequence": -1,
         "Id": {
           "value": "a2Lf4000000TvFmEAK",
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Record ID",
           "hidden": true,
           "fieldName": "Id",
           "editable": false,
           "dataType": "ID",
           "actions": {}
         },
         "vlocity_cmt__BillingAccountId__c": {
           "value": "001f40000093uqMAAQ",
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Account",
           "hidden": true,
           "fieldName": "vlocity_cmt__BillingAccountId__c",
           "editable": true,
           "dataType": "REFERENCE",
           "actions": {}
         },
         "vlocity_cmt__Action__c": {
           "value": "Change",
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Action",
           "hidden": true,
           "fieldName": "vlocity_cmt__Action__c",
           "editable": true,
           "dataType": "PICKLIST",
           "actions": {}
         },
         "vlocity_cmt__PromotionId__c": {
           "value": "a2ff4000000cHPMAA2",
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Promotion",
           "hidden": true,
           "fieldName": "vlocity_cmt__PromotionId__c",
           "editable": true,
           "dataType": "REFERENCE",
           "actions": {}
         },
         "vlocity_cmt__Sequence__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Sequence",
           "hidden": true,
           "fieldName": "vlocity_cmt__Sequence__c",
           "editable": true,
           "dataType": "DOUBLE",
           "actions": {}
         },
         "vlocity_cmt__FulfilmentStatus__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Fulfilment Status",
           "hidden": true,
           "fieldName": "vlocity_cmt__FulfilmentStatus__c",
           "editable": true,
           "dataType": "PICKLIST",
           "actions": {}
         },
         "vlocity_cmt__ReasonForCancellation__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Reason for Cancellation",
           "hidden": true,
           "fieldName": "vlocity_cmt__ReasonForCancellation__c",
           "editable": true,
           "dataType": "STRING",
           "actions": {}
         },
         "vlocity_cmt__RequestDate__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Request Date",
           "hidden": true,
           "fieldName": "vlocity_cmt__RequestDate__c",
           "editable": true,
           "dataType": "DATETIME",
           "actions": {}
         },
         "vlocity_cmt__SubAction__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Sub Action",
           "hidden": true,
           "fieldName": "vlocity_cmt__SubAction__c",
           "editable": true,
           "dataType": "PICKLIST",
           "actions": {}
         },
         "vlocity_cmt__CommitmentStartDate__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Commitment Start Date",
           "hidden": true,
           "fieldName": "vlocity_cmt__CommitmentStartDate__c",
           "editable": true,
           "dataType": "DATETIME",
           "actions": {}
         },
         "vlocity_cmt__CommitmentEndDate__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Commitment End Date",
           "hidden": true,
           "fieldName": "vlocity_cmt__CommitmentEndDate__c",
           "editable": true,
           "dataType": "DATETIME",
           "actions": {}
         },
         "vlocity_cmt__PricingStartDate__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Benefit Start Date",
           "hidden": true,
           "fieldName": "vlocity_cmt__PricingStartDate__c",
           "editable": true,
           "dataType": "DATETIME",
           "actions": {}
         },
         "vlocity_cmt__PricingEndDate__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Benefit End Date",
           "hidden": true,
           "fieldName": "vlocity_cmt__PricingEndDate__c",
           "editable": true,
           "dataType": "DATETIME",
           "actions": {}
         },
         "vlocity_cmt__AppliesTo__c": {
           "value": null,
           "previousValue": null,
           "originalValue": null,
           "messages": [],
           "label": "Applies To",
           "hidden": true,
           "fieldName": "vlocity_cmt__AppliesTo__c",
           "editable": true,
           "dataType": "PICKLIST",
           "actions": {}
         },
         "Name": "BundleJul19Promo",
         "Description": "BundleJul19Promo",
         "OrderRequestDate": "2017-11-13"
       }]
     }
      ```
    ```
    

### POST Add Promotion to a Cart

`POST /cpq/carts/{cartid}/promotions`

Operation ID: `Add Promotion to a Cart`. Tags: Cart.

Add promotion to a specified cart. Rest Handler - APIPromotionsCartsCpqV2 Method Invoked - postCartsPromoItems

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    

#### Request body

Request Body with input fields

#### Add Promotion to a Cart Request Example

```json
   {
     "items": [
       {
         "itemId":"a30460000001vbgAAA"
       }
     ],
     "price": false,
     "validate": false,
   }
```

Media type: `application/json`. Schema: `PostPromoCartResponse`.

#### Responses

*   **200** OK - API request processed. Look for messages in the response to determine if it succeeded or failed.

### DELETE Delete of Promotion Items in Cart.

`DELETE /cpq/carts/{cartid}/promotions`

Operation ID: `Delete Promotion Items`. Tags: Cart.

This API delete applied promotions items from cart Rest Handler - APIPromotionsCartsCpqV2 Method Invoked - deletePromotionItems

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `id` (query, string) Applied promotion item Id
    
    _Example_
    
    ```
    a2Lf40000008nL5EAI
    ```
    

#### Request body

Request Body with input fields

#### Delete Promotion Items in Cart Request Example

```json
  {
    "id": "a2Lf40000008nL5EAI",
    "cartId": "801f40000012NEIAA2",
    "methodName": "deleteAppliedPromoItems",
    "price": true,
    "validate": true
  }
```

Media type: `application/json`. Schema: `ValidateCartResponse`.

#### Responses

*   **200**
    
    #### Response for Delete Promotion Items
    
    ```json
      {
        "totalSize": 0,
        "messages": [{
          "severity": "INFO",
          "messageId": null,
          "message": "Successfully deleted.",
          "code": "152",
          "bundleId": null,
          "actions": {}
        }],
        "actions": {
          "itemdeleted": {
            "rest": {
              "params": {},
              "method": null,
              "link": null
            },
            "remote": {
              "params": {}
            },
            "client": {
              "params": {
                "items": [{
                  "message": "add TestProd-12 bundle has been deleted from the cart.",
                  "Id": "a2Lf40000008nL5EAI"
                }]
              }
            }
          }
        }
      }
    ```
    

### GET Get Applied Promotions for a Customer Account

`GET /accounts/{accountid}/promotions`

Operation ID: `Get Applied Promotions`. Tags: Customer.

Customers can have one or more active promotions applied which give them beneficial pricing or other benefits. This GET operation will retrieve any promotions applied to the given customer's assets, contracts or the account itself.

**includes** - By default the qualifications for each applied promotion are not returned in the response because they take time to calculate. Add the _includes=qualifications_ query parameter to request a list of required qualifications and which are satisfied or not satisfied. If the _includes=_ parameter is omitted, the _category_ field and _qualifications_ array will not be returned in the response. **Filters** - By default all of the applied promotions are returned in the response. The _filters_ parameter allows returning a subset.

Rest Handler - APIAppliedPromotionsAccountsV2 Method Invoked - getAppliedPromotionsByAccount

#### Parameters

*   `accountid` (path, string, required) Customer Account ID (Salesforce ID).
    
    _Example_
    
    ```
    001f4000007hynC
    ```
    
*   `includes` (query, string) Optional components to include in the response. Currently only _qualifications_.  
    Allowed values: `qualifications`.
*   `filters` (query, string) Filter field values.
    
    _Example_
    
    ```
    vlocity_cmt__AppliesTo__c:Account_Contract
    ```
    
*   `category` (query, string) Category to which the product belongs.
    
    _Example_
    
    ```
    Qualified, Disqualified
    ```
    
*   `fields` (query, array of string, collection format: csv) List of fields to return in the response, separated by commas.
    
    _Example_
    
    ```
    Id,Name
    ```
    
*   `pagesize` (query, integer) Number of records to be returned.
    
    _Example_
    
    ```
    10
    ```
    
*   `commitmentDateFilter` (query, string) Filters active applied promotions based on this date.
    
    _Example_
    
    ```
    2017-04-05T07:00:00.000Z
    ```
    
*   `appliedPromoStatusFilter` (query, string) Filter to specific the kind of applied promotions to be retrieved.
    
    _Example_
    
    ```
    Active
    ```
    
*   `ruleType` (query, string) Indicates which type of context rule to run. This should be used when we have includes param as qualifications or evaluation
    
    _Example_
    
    ```
    evaluation
    ```
    
*   `ruleEvaluationInput` (query, string) The input to be used in the evaluation of context rules
    
    _Example_
    
    ```
    {
      "Order": {
        "OriginatingChannel__c": "Web"
      }
    }
    ```
    

#### Responses

*   **200**
    
    #### Response for Account Applied Promotions
    
    ```json
          {
          "totalSize": 1,
          "messages": [],
          "records": [{
            "messages": [],
            "displaySequence": -1,
            "Id": {
              "value": "a1if4000000Z1wTAAS",
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Record ID",
              "hidden": true,
              "fieldName": "Id",
              "editable": false,
              "dataType": "ID",
              "actions": {}
            },
            "vlocity_cmt__BillingAccountId__c": {
              "value": "001f40000093uqMAAQ",
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Account",
              "hidden": true,
              "fieldName": "vlocity_cmt__BillingAccountId__c",
              "editable": false,
              "dataType": "REFERENCE",
              "actions": {}
            },
            "vlocity_cmt__PromotionId__c": {
              "value": "a2ff4000000cHPMAA2",
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Promotion",
              "hidden": true,
              "fieldName": "vlocity_cmt__PromotionId__c",
              "editable": true,
              "dataType": "REFERENCE",
              "actions": {}
            },
            "vlocity_cmt__Sequence__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Sequence",
              "hidden": true,
              "fieldName": "vlocity_cmt__Sequence__c",
              "editable": true,
              "dataType": "DOUBLE",
              "actions": {}
            },
            "vlocity_cmt__CancellationDate__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Cancellation Date",
              "hidden": true,
              "fieldName": "vlocity_cmt__CancellationDate__c",
              "editable": true,
              "dataType": "DATETIME",
              "actions": {}
            },
            "vlocity_cmt__CommitmentStartDate__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Commitment Start Date",
              "hidden": true,
              "fieldName": "vlocity_cmt__CommitmentStartDate__c",
              "editable": true,
              "dataType": "DATETIME",
              "actions": {}
            },
            "vlocity_cmt__AppliesTo__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Applies To",
              "hidden": true,
              "fieldName": "vlocity_cmt__AppliesTo__c",
              "editable": true,
              "dataType": "PICKLIST",
              "actions": {}
            },
            "vlocity_cmt__CancellationStatus__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Cancellation Status",
              "hidden": true,
              "fieldName": "vlocity_cmt__CancellationStatus__c",
              "editable": true,
              "dataType": "PICKLIST",
              "actions": {}
            },
            "vlocity_cmt__ReasonForCancellation__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Reason for Cancellation",
              "hidden": true,
              "fieldName": "vlocity_cmt__ReasonForCancellation__c",
              "editable": true,
              "dataType": "STRING",
              "actions": {}
            },
            "vlocity_cmt__CommitmentEndDate__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Commitment End Date",
              "hidden": true,
              "fieldName": "vlocity_cmt__CommitmentEndDate__c",
              "editable": true,
              "dataType": "DATETIME",
              "actions": {}
            },
            "vlocity_cmt__PricingStartDate__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Benefit Start Date",
              "hidden": true,
              "fieldName": "vlocity_cmt__PricingStartDate__c",
              "editable": true,
              "dataType": "DATETIME",
              "actions": {}
            },
            "vlocity_cmt__PricingEndDate__c": {
              "value": null,
              "previousValue": null,
              "originalValue": null,
              "messages": [],
              "label": "Benefit End Date",
              "hidden": true,
              "fieldName": "vlocity_cmt__PricingEndDate__c",
              "editable": true,
              "dataType": "DATETIME",
              "actions": {}
            },
            "Name": "BundleJul19Promo",
            "Description": "BundleJul19Promo"
          }]
        }
    ```
    

### GET Get List of Products

`GET /cpq/carts/{cartid}/products`

Operation ID: `Get List of Products`. Tags: Cart.

Get list of products available to be added to the cart based on the given criteria. Rest Handler - APIProductsCartsCpqV2 Method Invoked - getCartsProducts

#### Parameters

*   `cartid` (path, string, required) Cart ID (Salesforce ID). Opportunity, Quote or Order ID.
    
    _Example_
    
    ```
    801360000000oQ9
    ```
    
*   `maxProdListHierarchy` (query, integer) List of products returened in hierarchy.
    
    _Example_
    
    ```
    5
    ```
    
*   `lastRecordId` (query, string) The last record ID from the previous search result, if available.
    
    _Example_
    
    ```
    01uf4000001q1W3AAI
    ```
    
*   `includeAttachment` (query, boolean) Indicates whether product attachments are returned (true) or not (false).
    
    _Example_
    
    ```
    true
    ```
    
*   `filters` (query, string) Filter field values.
    
    _Example_
    
    ```
    vlocity_cmt__AppliesTo__c:Account_Contract
    ```
    
*   `offsetSize` (query, integer) Offset from which to start reading products, for pagination.
    
    _Example_
    
    ```
    2
    ```
    
*   `fields` (query, array of string, collection format: csv) List of fields to return in the response, separated by commas.
    
    _Example_
    
    ```
    Id,Name
    ```
    
*   `pagesize` (query, integer) Number of records to be returned.
    
    _Example_
    
    ```
    10
    ```
    
*   `attributes` (query, string) Attribute filters. For example, for the attribute memory (attributecode=attr1) with selected values 16gb and 32gb and attribute color (attr2) with red selected, the format will be as shown in the example.
    
    _Example_
    
    ```
    attr1:attr116gb_32gb,attr2:red
    ```
    
*   `includeAttributes` (query, boolean) Specifies whether to return a list of attributes and their values for the product.
    
    _Example_
    
    ```
    true
    ```
    
*   `query` (query, string) Search text
    
    _Example_
    
    ```
    iphone+6s
    ```
    

#### Responses

*   **200**
    
    #### Response for Get List of Products
    
    ```json
        {
    
           "totalSize": 5,
    
           "messages": [],
    
           "actions": {
    
              "nextproducts": {
    
                 "rest": {
    
                    "params": {},
    
                    "method": "GET",
    
                    "link": "/services/apexrest/vlcoity_cmt/v2/cpq/carts/80141000000Cg8HAAS/products?hierarchy=0&amp;lastRecordId=01u41000001QPtsAAG&amp;pagesize=5&amp;includeAttachment=false"
    
                 },
    
                 "remote": {
    
                    "params": {
    
                       "includeAttachment": false,
    
                       "pagesize": 5,
    
                       "lastRecordId": "01u41000001QPtsAAG",
    
                       "hierarchy": 0,
    
                       "cartId": "80141000000Cg8HAAS",
    
                       "methodName": "getCartsProducts"
    
                    }
    
                 },
    
                 "client": {
    
                    "params": {}
    
                 }
    
              }
    
           },
    
           "records": [{
    
              "messages": [],
    
              "actions": {
    
                 "addtocart": {
    
                    "rest": {
    
                       "params": {
    
                          "price": true,
    
                          "validate": true,
    
                          "includeAttachment": false,
    
                          "pagesize": 5,
    
                          "lastRecordId": null,
    
                          "hierarchy": 0,
    
                          "query": null,
    
                          "items": [{
    
                             "quantity": 1,
    
                             "itemId": "01u41000001QPs0AAG"
    
                          }]
    
                       },
    
                       "method": "POST",
    
                       "link": "/services/apexrest/vlocity_cmt/v2/cpq/carts/80141000000Cg8HAAS/items"
    
                    },
    
                    "remote": {
    
                       "params": {
    
                          "price": true,
    
                          "validate": true,
    
                          "includeAttachment": false,
    
                          "pagesize": 5,
    
                          "lastRecordId": null,
    
                          "hierarchy": 0,
    
                          "query": null,
    
                          "items": [{
    
                             "quantity": 1,
    
                             "itemId": "01u41000001QPs0AAG"
    
                          }],
    
                          "cartId": "80141000000Cg8HAAS",
    
                          "methodName": "postCartsItems"
    
                       }
    
                    },
    
                    "client": {
    
                       "params": {}
    
                    }
    
                 }
    
              },
    
              "displaySequence": -1,
    
              "Id": {
    
                 "label": "Price Book Entry ID",
    
                 "value": "01u41000001QPs0AAG"
    
              },
    
              "Pricebook2Id": {
    
                 "label": "Price Book ID",
    
                 "value": "01s41000005dPYQAA2"
    
              },
    
              "Product2Id": {
    
                 "label": "Product ID",
    
                 "value": "01t41000000sYZQAA2"
    
              },
    
              "UnitPrice": {
    
                 "label": "List Price",
    
                 "value": 1.00
    
              },
    
              "Name": {
    
                 "label": "Product Name",
    
                 "value": "Root 1"
    
              },
    
              "IsActive": {
    
                 "label": "Active",
    
                 "value": true
    
              },
    
              "Product2": {
    
                 "attributes": {
    
                    "type": "Product2",
    
                    "url": "/services/data/v38.0/sobjects/Product2/01t41000000sYZQAA2"
    
                 },
    
                 "Id": "01t41000000sYZQAA2",
    
                 "Name": "Root 1",
    
                 "vlocity_cmt__IsConfigurable__c": false,
    
                 "vlocity_cmt__Type__c": "None",
    
                 "vlocity_cmt__SubType__c": "None",
    
                 "RecordTypeId": "012410000006OWUAA2"
    
              },
    
              "productId": "01t41000000sYZQAA2",
    
              "defaultQuantity": 1.0,
    
              "minQuantity": 0.0,
    
              "maxQuantity": 99999.0,
    
              "groupMinQuantity": 0,
    
              "groupMaxQuantity": 99999,
    
              "sequenceNumber": 1.00,
    
              "productChildItemId": "a2541000000G09wAAC",
    
              "productChildItemDefinition": {
    
                 "attributes": {
    
                    "type": "vlocity_cmt__ProductChildItem__c",
    
                    "url": "/services/data/v38.0/sobjects/vlocity_cmt__ProductChildItem__c/a2541000000G09wAAC"
    
                 },
    
                 "Id": "a2541000000G09wAAC",
    
                 "Name": "Root PCI",
    
                 "vlocity_cmt__IsVirtualItem__c": false,
    
                 "vlocity_cmt__Quantity__c": 1,
    
                 "vlocity_cmt__MaxQuantity__c": 99999,
    
                 "vlocity_cmt__MinQuantity__c": 0,
    
                 "vlocity_cmt__MaximumChildItemQuantity__c": 99999,
    
                 "vlocity_cmt__MinimumChildItemQuantity__c": 0,
    
                 "vlocity_cmt__IsOverride__c": false,
    
                 "vlocity_cmt__ParentProductId__c": "01t41000000sYZQAA2",
    
                 "vlocity_cmt__ChildLineNumber__c": "1",
    
                 "vlocity_cmt__SeqNumber__c": 1.00,
    
                 "vlocity_cmt__CollapseHierarchy__c": false,
    
                 "vlocity_cmt__IsRootProductChildItem__c": true,
    
                 "vlocity_cmt__ParentProductId__r": {
    
                    "attributes": {
    
                       "type": "Product2",
    
                       "url": "/services/data/v38.0/sobjects/Product2/01t41000000sYZQAA2"
    
                    },
    
                    "Id": "01t41000000sYZQAA2",
    
                    "Name": "Root 1"
    
                 }
    
              },
    
              "productHierarchyPath": "01t41000000sYZQAA2",
    
              "name": "Root 1",
    
              "isVirtualItem": false,
    
              "attributeValues": {},
    
              "itemType": "childProduct"
    
           }, {
    
              "messages": [],
    
              "actions": {
    
                 "addtocart": {
    
                    "rest": {
    
                       "params": {
    
                          "price": true,
    
                          "validate": true,
    
                          "includeAttachment": false,
    
                          "pagesize": 5,
    
                          "lastRecordId": null,
    
                          "hierarchy": 0,
    
                          "query": null,
    
                          "items": [{
    
                             "quantity": 1,
    
                             "itemId": "01u41000001QPs5AAG"
    
                          }]
    
                       },
    
                       "method": "POST",
    
                       "link": "/services/apexrest/vlocity_cmt/v2/cpq/carts/80141000000Cg8HAAS/items"
    
                    },
    
                    "remote": {
    
[...]
